/*
 * uc3_delay.c
 *
 *  	Created on: 10.10.2012
 *      Author: 	Zippi
 *      File:		delay Driver
 *
 *      Beschreibung:
 *      	Delay Funktionen um eine bestimmte Zeit zu warten.
 *			CPU Driver und CPU Setup erforderlich.
 *
 *      Beispiel:
 *			wait_ms(10);						// wartet 10 Millisekunden.
 */
#include <avr32/io.h>
#include <stdlib.h>
#include "uc3_cpu.h"
#include "uc3_delay.h"

void wait_ns(int time)
{
	int waittime;
	int delay;
	int time2;

	time2 = __builtin_mfsr(AVR32_COUNT);
	delay = (time * cpu_get_clk())/1000;
	waittime = __builtin_mfsr(AVR32_COUNT) - time2;

	while(waittime<delay)
	{
		volatile unsigned int counter = __builtin_mfsr(AVR32_COUNT);
		waittime += counter - time2;
		time2 = counter;
	}

}

void wait_us(int time)
{
	int waittime;
	int delay;
	int time2;

	time2 = __builtin_mfsr(AVR32_COUNT);
	delay = time * cpu_get_clk();
	waittime = __builtin_mfsr(AVR32_COUNT) - time2;

	while(waittime<delay)
	{
		volatile unsigned int counter = __builtin_mfsr(AVR32_COUNT);
		waittime += counter - time2;
		time2 = counter;
	}

}

void wait_ms(int time)
{
	wait_us(time*1000);
}
